import { __decorate } from 'tslib';
import { Injectable, ViewContainerRef, Component, Injector, ViewChild, HostListener, ComponentFactoryResolver, ApplicationRef, ɵɵdefineInjectable, ɵɵinject, ElementRef, Directive, NgModule } from '@angular/core';
import { Subject } from 'rxjs';
import { CommonModule } from '@angular/common';

var MDynamicDialogData = /** @class */ (function () {
    function MDynamicDialogData() {
    }
    MDynamicDialogData = __decorate([
        Injectable()
    ], MDynamicDialogData);
    return MDynamicDialogData;
}());

var MDynamicDialogReference = /** @class */ (function () {
    function MDynamicDialogReference() {
        this.onSave = new Subject();
        this.onClose = new Subject();
        this.saveButtonEnabled = true;
        this.closeButtonEnabled = true;
        this.getForm = new Subject();
        var date = new Date();
        this.dialogId = "dialog-" + date.getHours() + date.getMinutes() + date.getSeconds() + date.getMilliseconds();
        this.listenForCloseDialog();
    }
    MDynamicDialogReference.prototype.useForm = function (form) {
        this.getForm.next(form);
    };
    MDynamicDialogReference.prototype.save = function (data) {
        this.onSave.next(data);
    };
    MDynamicDialogReference.prototype.close = function (data) {
        this.onClose.next(data);
    };
    MDynamicDialogReference.prototype.listenForCloseDialog = function () {
        var _this = this;
        this.onClose.subscribe(function (res) {
            var dialog = document.getElementById(_this.dialogId);
            var container = document.getElementById("m-dynamic-dialog-container");
            container.removeChild(dialog);
            var childrenCount = container.childElementCount;
            if (childrenCount == 0) {
                document.body.removeChild(container);
            }
        });
    };
    MDynamicDialogReference = __decorate([
        Injectable()
    ], MDynamicDialogReference);
    return MDynamicDialogReference;
}());

var MDynamicDialogBodyComponent = /** @class */ (function () {
    function MDynamicDialogBodyComponent(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    MDynamicDialogBodyComponent.prototype.ngOnInit = function () {
    };
    MDynamicDialogBodyComponent.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    MDynamicDialogBodyComponent = __decorate([
        Component({
            selector: 'm-dynamic-dialog-body',
            template: "",
            styles: [""]
        })
    ], MDynamicDialogBodyComponent);
    return MDynamicDialogBodyComponent;
}());

var MDynamicDialogComponent = /** @class */ (function () {
    function MDynamicDialogComponent(ref) {
        this.ref = ref;
        this.id = "";
        this.headerHeight = "7vh";
        this.footerHeight = "5vh";
        this.bodyHeight = "";
        this.loaded = false;
        this.componentFactoryResolver = null;
        this.animationType = 0;
        this.animationTypes = AnimationTypes;
        this.form = null;
    }
    MDynamicDialogComponent.prototype.handleKeyboardEvent = function (event) {
        if (this.parameter.Properties.closeOnEsc !== false) {
            this.close();
        }
    };
    MDynamicDialogComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.calculateDialogPropertiesAndSet(this.parameter.Properties);
        this.ref.getForm.subscribe(function (res) {
            console.log(res);
            _this.form = res;
        });
    };
    MDynamicDialogComponent.prototype.log = function (ss) {
        console.log("log from dialog container", ss);
    };
    MDynamicDialogComponent.prototype.ngAfterViewInit = function () {
        this.createComponent(this.componentFactoryResolver);
    };
    MDynamicDialogComponent.prototype.setComponentBuilders = function (cfr) {
        this.componentFactoryResolver = cfr;
    };
    MDynamicDialogComponent.prototype.calculateDialogPropertiesAndSet = function (properties) {
        if (properties.headerHeight) {
            this.headerHeight = properties.headerHeight;
        }
        if (properties.footerHeight) {
            this.footerHeight = properties.footerHeight;
        }
        if (properties.showHeader === true)
            this.headerHeight = "0";
        if (properties.showFooter === true)
            this.footerHeight = "0";
        this.bodyHeight = properties.height;
        this.loaded = true;
        return this;
    };
    MDynamicDialogComponent.prototype.createComponent = function (cfr) {
        var injector = Injector.create({
            providers: [
                {
                    provide: MDynamicDialogReference,
                    useValue: this.ref
                },
                {
                    provide: MDynamicDialogData,
                    useValue: this.dialogData
                }
            ]
        });
        var dynamicComponent = cfr.resolveComponentFactory(this.parameter.Component);
        if (dynamicComponent.selector == 'm-confirmation-dialog') {
            this.animationType = AnimationTypes.Confirmation;
        }
        else {
            this.animationType = AnimationTypes.Dynamic;
        }
        this.content.viewContainerRef.createComponent(dynamicComponent, 0, injector);
    };
    MDynamicDialogComponent.prototype.saveButtonEnabled = function () {
        return this.ref.saveButtonEnabled;
    };
    MDynamicDialogComponent.prototype.save = function () {
        this.ref.save();
    };
    MDynamicDialogComponent.prototype.close = function () {
        this.ref.close();
    };
    MDynamicDialogComponent.prototype.outsideClickClose = function () {
        this.ref.close();
    };
    MDynamicDialogComponent.ctorParameters = function () { return [
        { type: MDynamicDialogReference }
    ]; };
    __decorate([
        ViewChild(MDynamicDialogBodyComponent)
    ], MDynamicDialogComponent.prototype, "content", void 0);
    __decorate([
        HostListener('document:keydown.escape', ['$event'])
    ], MDynamicDialogComponent.prototype, "handleKeyboardEvent", null);
    MDynamicDialogComponent = __decorate([
        Component({
            selector: 'm-dynamic',
            template: "<!-- \r\n\r\n            [ngClass]=\"{\r\n            'm-dynamic-dialog': animationType === animationTypes.Dynamic, \r\n            'm-confirmation-dialog': animationType === animationTypes.Confirmation ,\r\n            'm-dynamic-dialog-hide': animationType === 0,\r\n            'm-confirmation-dialog-hide': animationType === 0\r\n        }\" hideConfirmation m-dynamic-dialog-hide\r\n -->\r\n\r\n<div class=\"m-dialog-environment\" [ngClass]=\"{'m-modal-background': parameter.Properties?.asModal !== false}\">\r\n    <div *ngIf=\"loaded\" class=\"m-dialog-container m-card m-no-padding\"\r\n\r\n        [ngStyle]=\"{'min-width': parameter.Properties?.width, 'max-width': parameter.Properties?.width}\">\r\n        <div *ngIf=\"parameter.Properties?.showHeader !== false\" class=\"m-header m-min-padding\" [ngStyle]=\"{\r\n                'height': headerHeight , \r\n                'width': parameter.Properties?.width\r\n            }\">\r\n            <div class=\"m-title\">\r\n                {{ parameter.Properties?.title }}\r\n            </div>\r\n            <span (click)=\"close()\">\r\n                <!-- <i class=\"fas fa-times m-pointer m-header-close\"></i> -->\r\n                <span class=\"close rounded heavy m-pointer m-header-close\"></span>\r\n            </span>\r\n        </div>\r\n\r\n        <div class=\"m-body\" [ngStyle]=\"{\r\n                'height': bodyHeight ? bodyHeight : '100%', \r\n                'width': parameter.Properties?.width ? parameter.Properties?.width : '100%'\r\n            }\">\r\n            <m-dynamic-dialog-body #content></m-dynamic-dialog-body>\r\n        </div>\r\n\r\n        <div *ngIf=\"parameter.Properties?.showFooter !== false\" class=\"m-footer m-min-padding\" [ngStyle]=\"{\r\n                'height': footerHeight, \r\n                'width': parameter.Properties?.width\r\n            }\">\r\n            <div class=\"m-min-padding\" *ngIf=\"parameter.Properties?.showCloseButton !== false\">\r\n                <button mButton (click)=\"close()\">\r\n                    {{ parameter.Properties?.closeButtonLabel ? parameter.Properties?.closeButtonLabel : 'Cancel' }}\r\n                </button>\r\n            </div>\r\n            <div class=\"m-min-padding\" *ngIf=\"parameter.Properties?.showSaveButton !== false\">\r\n                <button mButton [disabled]=\"form === null ? false : !form.valid\" (click)=\"save()\">\r\n                    {{ parameter.Properties?.closeButtonLabel ? parameter.Properties?.saveButtonLabel : 'Save' }}\r\n                </button>\r\n            </div>\r\n\r\n        </div>\r\n\r\n    </div>\r\n</div>",
            styles: ["button{outline:0}.m-dialog-wrapper{height:100%;width:100%}.m-modal-background{background:rgba(0,0,0,.5)}.m-card{background:#fff!important;border-radius:2px!important;display:inline-block!important;box-shadow:0 19px 38px rgba(0,0,0,.3),0 15px 12px rgba(0,0,0,.22)!important}.m-min-padding{padding:1vh!important}.m-pointer{cursor:pointer}.m-no-padding{padding:0}::-webkit-scrollbar{width:.8em;border-radius:.5em}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:#555}.m-dialog-container{position:absolute;border:0!important;box-shadow:0 12px 15px 0 rgba(0,0,0,.25)}.m-dynamic-dialog-show{opacity:0;-webkit-animation-name:showDynamic;animation-name:showDynamic;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}.m-confirmation-dialog-show{opacity:0;-webkit-animation-name:showConfirmation;animation-name:showConfirmation;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}.m-dynamic-dialog-hide{opacity:1;bottom:29%;-webkit-animation-name:hideDynamic;animation-name:hideDynamic;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}.m-confirmation-dialog-hide{opacity:0;-webkit-animation-name:hideConfirmation;animation-name:hideConfirmation;-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-fill-mode:forwards;animation-fill-mode:forwards}@-webkit-keyframes showDynamic{30%{bottom:0;opacity:0}100%{bottom:29%;opacity:1}}@keyframes showDynamic{30%{bottom:0;opacity:0}100%{bottom:29%;opacity:1}}@-webkit-keyframes hideDynamic{0%{bottom:29%;opacity:1}100%{bottom:0;opacity:0}}@keyframes hideDynamic{0%{bottom:29%;opacity:1}100%{bottom:0;opacity:0}}@-webkit-keyframes showConfirmation{0%{opacity:0}100%{opacity:1}}@keyframes showConfirmation{0%{opacity:0}100%{opacity:1}}@-webkit-keyframes hideConfirmation{0%{opacity:1}100%{opacity:0}}@keyframes hideConfirmation{0%{opacity:1}100%{opacity:0}}.m-dialog-environment{height:100%!important;width:100%!important;z-index:1000000000!important;position:absolute!important;display:flex!important;justify-content:center!important;align-items:center!important;overflow:hidden!important;top:0!important;left:0!important;right:0!important;bottom:0!important}.m-header{display:flex;justify-content:space-between;align-items:center;box-sizing:border-box!important;box-shadow:0 0 .5em rgba(0,0,0,.16)}.m-title{font-size:1.5em}.m-header-close{font-size:1.1em}.m-body{padding:1vh;overflow-y:auto;box-sizing:border-box!important}.m-footer{display:flex;justify-content:flex-end;align-items:center;box-shadow:0 0 1em rgba(0,0,0,.16);box-sizing:border-box!important}"]
        })
    ], MDynamicDialogComponent);
    return MDynamicDialogComponent;
}());
var AnimationTypes;
(function (AnimationTypes) {
    AnimationTypes[AnimationTypes["Dynamic"] = 1] = "Dynamic";
    AnimationTypes[AnimationTypes["Confirmation"] = 2] = "Confirmation";
})(AnimationTypes || (AnimationTypes = {}));

var MDynamicDialogParameter = /** @class */ (function () {
    function MDynamicDialogParameter() {
    }
    return MDynamicDialogParameter;
}());

var MConfirmationDialogComponent = /** @class */ (function () {
    function MConfirmationDialogComponent(dialogData, ref) {
        this.dialogData = dialogData;
        this.ref = ref;
        this.properties = null;
        this.properties = dialogData.data.properties;
    }
    MConfirmationDialogComponent.prototype.ngOnInit = function () {
    };
    MConfirmationDialogComponent.prototype.close = function () {
        this.ref.close();
    };
    MConfirmationDialogComponent.prototype.yesClick = function () {
        this.ref.close(true);
    };
    MConfirmationDialogComponent.prototype.noClick = function () {
        this.ref.close(false);
    };
    MConfirmationDialogComponent.ctorParameters = function () { return [
        { type: MDynamicDialogData },
        { type: MDynamicDialogReference }
    ]; };
    MConfirmationDialogComponent = __decorate([
        Component({
            selector: 'm-confirmation-dialog',
            template: "<div class=\"confirmation-container\">\n        <!-- <div class=\"title\">\n            {{properties?.title}}\n        </div> -->\n        <div class=\"message\" [innerHTML]=\"properties?.message\">\n        </div>\n    <div class=\"buttons\">\n        <button mButton (click)=\"yesClick()\">{{ properties?.yesButtonLabel ? properties?.yesButtonLabel : 'Yes' }}</button>\n        <button mButton (click)=\"noClick()\">{{ properties?.noButtonLabel ? properties?.noButtonLabel : 'No' }}</button>\n    </div>\n</div>",
            styles: ["button{outline:0}.m-dialog-wrapper{height:100%;width:100%}.m-modal-background{background:rgba(0,0,0,.5)}.m-card{background:#fff!important;border-radius:2px!important;display:inline-block!important;box-shadow:0 19px 38px rgba(0,0,0,.3),0 15px 12px rgba(0,0,0,.22)!important}.m-min-padding{padding:1vh!important}.m-pointer{cursor:pointer}.m-no-padding{padding:0}::-webkit-scrollbar{width:.8em;border-radius:.5em}::-webkit-scrollbar-track{background:#f1f1f1}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:#555}.confirmation-container{height:100%;width:100%}.message{display:flex;justify-content:center;align-items:center;font-size:1.3em;height:70%;width:100%;overflow-y:auto;font-weight:300}.buttons{height:30%;width:100%;display:flex;flex-direction:row;justify-content:space-around;align-items:center;font-size:1.2em;font-weight:400}"]
        })
    ], MConfirmationDialogComponent);
    return MConfirmationDialogComponent;
}());

var MDynamicDialogService = /** @class */ (function () {
    function MDynamicDialogService(componentFactoryResolver, applicationRef) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.applicationRef = applicationRef;
    }
    MDynamicDialogService.prototype.createAndGetDialogReferenceInstance = function (parameter) {
        var reference = new MDynamicDialogReference();
        this.generateBaseDialog(reference, parameter);
        return reference;
    };
    MDynamicDialogService.prototype.checkIfDialogContExist = function () {
        var container = document.getElementById("m-dynamic-dialog-container");
        return container != null;
    };
    MDynamicDialogService.prototype.generateBaseDialog = function (reference, parameter) {
        if (!this.checkIfDialogContExist()) {
            this.generateDialogContainer();
        }
        var injectorCustom = Injector.create([
            {
                provide: MDynamicDialogReference,
                useValue: reference
            },
        ]);
        var dialogFactory = this.componentFactoryResolver.resolveComponentFactory(MDynamicDialogComponent).create(injectorCustom);
        dialogFactory.instance.setComponentBuilders(this.componentFactoryResolver);
        dialogFactory.instance.parameter = parameter;
        // dialogFactory.instance.form = parameter.Properties.
        dialogFactory.instance.dialogData = this.generateDialogData(parameter.Properties.data);
        this.applicationRef.attachView(dialogFactory.hostView);
        var dialog = dialogFactory.hostView.rootNodes[0];
        dialog.id = reference.dialogId;
        var dialogContainer = document.getElementById("m-dynamic-dialog-container");
        dialogContainer.append(dialog);
        this.applicationRef.tick();
    };
    MDynamicDialogService.prototype.generateDialogContainer = function () {
        var dialogContainer = document.createElement("div");
        dialogContainer.id = "m-dynamic-dialog-container";
        // dialogContainer.style.height = "100%";
        // dialogContainer.style.width = "100%";
        dialogContainer.style.position = "absolute !important";
        dialogContainer.style.background = "background: rgba(0, 0, 0, 0.5); !important";
        document.body.insertBefore(dialogContainer, document.body.firstChild);
    };
    MDynamicDialogService.prototype.generateDialogData = function (data) {
        var dialogData = new MDynamicDialogData();
        dialogData.data = data;
        return dialogData;
    };
    MDynamicDialogService.prototype.open = function (component, properties) {
        var parameter = new MDynamicDialogParameter();
        parameter.Component = component;
        parameter.Properties = properties;
        return this.createAndGetDialogReferenceInstance(parameter);
    };
    MDynamicDialogService.prototype.openConfirmation = function (properties) {
        return this.open(MConfirmationDialogComponent, {
            title: properties.title,
            height: properties.height ? properties.height : '20vh',
            width: properties.width ? properties.width : '20vw',
            data: {
                properties: properties
            },
            showFooter: false
        });
    };
    MDynamicDialogService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef }
    ]; };
    MDynamicDialogService.ɵprov = ɵɵdefineInjectable({ factory: function MDynamicDialogService_Factory() { return new MDynamicDialogService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef)); }, token: MDynamicDialogService, providedIn: "root" });
    MDynamicDialogService = __decorate([
        Injectable({
            providedIn: "root"
        })
    ], MDynamicDialogService);
    return MDynamicDialogService;
}());

var MButtonDirective = /** @class */ (function () {
    /*
    
        height: 2vh;
        width: 3vw;
        display: flex;
        justify-content: space-between;
        align-items: center;
    */
    function MButtonDirective(el) {
        el.nativeElement.style.height = '2vh';
        el.nativeElement.style.width = '3vw';
        el.nativeElement.style.background = 'transparent';
        el.nativeElement.style.border = '0';
        el.nativeElement.className = "m-pointer";
        el.nativeElement.style.fontSize = "1.1em";
    }
    MButtonDirective.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    MButtonDirective = __decorate([
        Directive({
            selector: '[mButton]'
        })
    ], MButtonDirective);
    return MButtonDirective;
}());

var MDynamicDialogModule = /** @class */ (function () {
    function MDynamicDialogModule() {
    }
    MDynamicDialogModule_1 = MDynamicDialogModule;
    MDynamicDialogModule.forRoot = function () {
        return {
            ngModule: MDynamicDialogModule_1,
            providers: [MDynamicDialogService, MDynamicDialogReference, MDynamicDialogData, MDynamicDialogParameter]
        };
    };
    var MDynamicDialogModule_1;
    MDynamicDialogModule = MDynamicDialogModule_1 = __decorate([
        NgModule({
            declarations: [
                MDynamicDialogBodyComponent,
                MDynamicDialogComponent,
                MConfirmationDialogComponent,
                MButtonDirective
            ],
            imports: [
                CommonModule
            ],
            entryComponents: [
                MDynamicDialogBodyComponent,
                MDynamicDialogComponent,
                MConfirmationDialogComponent
            ],
            exports: [
                MDynamicDialogBodyComponent
            ]
        })
    ], MDynamicDialogModule);
    return MDynamicDialogModule;
}());

var MDynamicDialogProperties = /** @class */ (function () {
    function MDynamicDialogProperties() {
    }
    return MDynamicDialogProperties;
}());

/*
 * Public API Surface of c-dialog
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AnimationTypes, MConfirmationDialogComponent, MDynamicDialogBodyComponent, MDynamicDialogComponent, MDynamicDialogData, MDynamicDialogModule, MDynamicDialogParameter, MDynamicDialogProperties, MDynamicDialogReference, MDynamicDialogService, MButtonDirective as ɵa };
//# sourceMappingURL=m-dynamic-dialog.js.map
