import { ComponentFactoryResolver } from '@angular/core';
import { MDynamicDialogData } from '../m-dynamic-dialog-services/m-dynamic-dialog-data.service';
import { MDynamicDialogReference } from '../m-dynamic-dialog-services/m-dynamic-dialog-reference.service';
import { MDynamicDialogParameter } from '../models/m-dynamic-dialog-parameter';
import { MDynamicDialogProperties } from '../models/m-dynamic-dialog-properties';
import { NgForm } from '@angular/forms';
export declare class MDynamicDialogComponent {
    private ref;
    id: string;
    headerHeight: string;
    footerHeight: string;
    bodyHeight: string;
    loaded: boolean;
    parameter: MDynamicDialogParameter;
    dialogData: MDynamicDialogData;
    componentFactoryResolver: ComponentFactoryResolver;
    animationType: number;
    animationTypes: typeof AnimationTypes;
    content: any;
    form: NgForm;
    constructor(ref: MDynamicDialogReference);
    handleKeyboardEvent(event: KeyboardEvent): void;
    ngOnInit(): void;
    log(ss: any): void;
    ngAfterViewInit(): void;
    setComponentBuilders(cfr: ComponentFactoryResolver): void;
    calculateDialogPropertiesAndSet(properties: MDynamicDialogProperties): this;
    createComponent(cfr: ComponentFactoryResolver): void;
    saveButtonEnabled(): boolean;
    save(): void;
    close(): void;
    outsideClickClose(): void;
}
export declare enum AnimationTypes {
    Dynamic = 1,
    Confirmation = 2
}
